Core - Bug # 56660

Status: Resolved Priority: Should have
Author: Tymoteusz Motylewski Category:

Created: 2014-03-07 Assigned To:

Updated: 2014-03-11 Due date:

TYPO3 Version: 6.2

PHP Version:

Complexity: no-brainer

Is Regression: No

Sprint Focus:

Subject: Interface incompatibility - PackageManager initialize() - backport from Flow

Description

PackageManagerinterface contains following method declaration:
public function initialize(\TYPO3\Flow\Core\Bootstrap $bootstrap);

however in the PackageManager (which implements \TYPO3\Flow\Package\PackageManagerinterface)

it is implemented like this:

public function initialize(\TYPO3\Flow\Core\Bootstrap $bootstrap, $packagesBasePath = FLOW_PATH_PACKAGES,

$packageStatesPathAndFilename = ") {

this is wrong and will fatal on some versions of php, see http://php.net/manual/en/language.oop5.interfaces.php

"The class implementing the interface must use the exact same method signatures as are defined in the interface. Not doing so will

result in a fatal error."

The issue was aready solved in Flow, see
http://forge.typo3.org/issues/56409

So we just need to backport the patch.

Related issues:
related to TYPOS.Flow - Bug # 56409: Interface incompatibility - PackageManager

Resolved 2014-02-28

Associated revisions

Revision 61a9d4bc - 2014-03-11 19:12 - Wouter Wolters

[BUGFIX] PackageManager initialize() signature is incompatible

PackageManagerinterface contains following method declaration:
public function initialize(\TYPO3\Flow\Core\Bootstrap $bootstrap);

however in the PackageManager the signature is:
public function initialize(\TYPO3\Flow\Core\Bootstrap $bootstrap,
$packagesBasePath = FLOW_PATH_PACKAGES,
$packageStatesPathAndFilename = ")

This will create a fatal error on some versions of php and when running
unit tests on hhvm (of CMS), see
http://php.net/manual/en/language.oop5.interfaces.php

"The class implementing the interface must use the exact same method
signatures as are defined in the interface. Not doing so will result

in a fatal error."

This change updates the method signature of the PackageManager to be in
line with the interface.

Resolves: #56660

Related: #56409

Releases: 6.2

Change-Id: lab7ae0d6d9809abe7cb6f9b73adb77f06d2f0820
Reviewed-on: https://review.typo3.org/28195

Reviewed-by: Thomas Maroschik
Reviewed-by: Sebastian Muller
Reviewed-by: Sebastian Fischer
Reviewed-by: Steffen Ritter
Tested-by: Steffen Ritter
Reviewed-by: Markus Klein
Tested-by: Markus Klein

Revision bab84b55 - 2014-03-11 20:17 - Steffen Ritter

[BUGFIX] FollowUp to #56660

Fixes the unit-test according to the changes in review
https://review.typo3.org/#/c/28195/.

Since the BasePath (and therefore vfs://...) cannot be
handover anymore on initialize() it has to be injected

via _set().

Releases: 6.2

Resolves: #56660

Change-Id: 188d03f0305ff08810d6fea82c5c891b1a7a99771
Reviewed-on: https://review.typo3.0rg/28270

Reviewed-by: Wouter Wolters
Tested-by: Wouter Wolters
Reviewed-by: Steffen Ritter
Tested-by: Steffen Ritter

History

#1 - 2014-03-09 16:22 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/28195

#2 - 2014-03-09 16:35 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

2015-08-04

2/3


https://review.typo3.org/28195
https://review.typo3.org/#/c/28195/
https://review.typo3.org/28270
https://review.typo3.org/28195

It is available at https://review.typo3.org/28195

#3 - 2014-03-09 16:36 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/28195

#4 - 2014-03-09 16:54 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/28195

#5 - 2014-03-09 17:49 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/28195

#6 - 2014-03-10 12:36 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/28195

#7 - 2014-03-11 19:30 - Wouter Wolters
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:61a9d4bc330ccd70a2e3f64b328ab0215d52d4ab.

#8 - 2014-03-11 20:12 - Gerrit Code Review

- Status changed from Resolved to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/28270

#9 - 2014-03-11 20:30 - Steffen Ritter
- Status changed from Under Review to Resolved

Applied in changeset commit:bab84b55a92f0c09a201d567d04fc63eeef230a3.
